{ Autor....: Daniel Pereira Guimares
  E-mail...: tecnobyte@ulbrajp.com.br
  Home-Page: www.ulbrajp.com.br/~tecnobyte

  Programa.: Barra de Ttulo Improvisada
}

unit uTBTitle;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, Menus, Spin, ShellApi;

type
  TForm1 = class(TForm)
    PopupMenu1: TPopupMenu;
    mniClose: TMenuItem;
    Panel2: TPanel;
    Panel1: TPanel;
    Image1: TImage;
    btnClose: TSpeedButton;
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Panel1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure mniCloseClick(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Image1DblClick(Sender: TObject);
    procedure Panel1Resize(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Label5Click(Sender: TObject);
  private
    OldX,
    OldY,
    OldLeft,
    OldTop   : Integer;
    ScreenDC : HDC;
    MoveRect : TRect;
    Moving   : Boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Panel1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then begin
    SetCapture(Panel1.Handle);
    ScreenDC := GetDC(0);
    OldX := X;
    OldY := Y;
    OldLeft := X;
    OldTop := Y;
    MoveRect := BoundsRect;
    DrawFocusRect(ScreenDC,MoveRect);
    Moving := True;
  end;
end;

procedure TForm1.Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if Moving then begin
    DrawFocusRect(ScreenDC,MoveRect);
    OldX := X;
    OldY := Y;
    MoveRect := Rect(Left+OldX-OldLeft,Top+OldY-OldTop,
                     Left+Width+OldX-OldLeft,Top+Height+OldY-OldTop);
    DrawFocusRect(ScreenDC,MoveRect);
  end;
end;

procedure TForm1.Panel1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then begin
    ReleaseCapture;
    DrawFocusRect(ScreenDC,MoveRect);
    Left := Left+X-OldLeft;
    Top := Top+Y-OldTop;
    ReleaseDC(0,ScreenDC);
    Moving := False;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  BorderStyle := bsNone;

  { Configura o Panel para ficar parecido com a barra de
    ttulo }
  Panel1.Height := GetSystemMetrics(SM_CYCAPTION);
  Panel1.Color := clActiveCaption;
  Panel1.Font.Color := clCaptionText;
  Panel1.Font.Style := [fsBold];
  Panel1.Caption := 'Barra de Ttulo Improvisada';

  SpinEdit1.Value := Panel1.Height;

  { Coloca Caption do Panel1 no Caption do Form para ser
    exibido quando usar Alt+Tab }
  Caption := Panel1.Caption;

  { O Panel2 funciona como borda para o form }
  Panel2.BorderWidth := GetSystemMetrics(SM_CXBORDER);
  Panel2.BevelWidth := 1;

  Image1.Stretch := true;
  btnClose.OnClick := mniClose.OnClick;

  Panel1Resize(nil);
end;

procedure TForm1.mniCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Image1Click(Sender: TObject);
var
  Pt: TPoint;
begin
  Pt.X := Image1.Left;
  Pt.Y := Image1.Top + Image1.Height + 1;
  Pt := Panel1.ClientToScreen(Pt);
  PopupMenu1.Popup(Pt.X, Pt.Y);
end;

procedure TForm1.Image1DblClick(Sender: TObject);
begin
  mniClose.Click;
end;

procedure TForm1.Panel1Resize(Sender: TObject);
var
  I: integer;
begin
  I := Panel1.Height;

  Image1.Left := 1;
  Image1.Top := 1;
  Image1.Height := I-1;
  Image1.Width := I-1;

  btnClose.Top := 2;
  btnClose.Left := Panel1.ClientWidth - btnClose.Width - 2;
  btnClose.Height := I-2;
  btnClose.Width := I-2;
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  Panel1.Height := SpinEdit1.Value;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then
    BorderStyle := bsSizeable
  else
    BorderStyle := bsNone;  
end;

procedure TForm1.Label5Click(Sender: TObject);
begin
  ShellExecute(0, 'open', 'mailto:tecnobyte@ulbrajp.com.br',
    nil, nil, 0);
end;

end.
